$INTERFACE UF1FM1                                             97/12/01
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     -------------------------
*     NUMERICAL DIFFERENTIATION
*     -------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INTEGER,'\ISNS')
      ISNS=ISNA
 $00  CALL UF1FM1
      GOTO ($30,$10,$20) ISB+1
 $10  CONTINUE
      $W=GF
      $GF=G
      IF(TSS(NS).NE.'UFXX') CALL UYSET2
      $KD=0
      $SUBST('UZMODL')
      $KD=1
      LD=MIN(LD,0)
      FF=F
      IF(TSS(NS).EQ.'UFXX') GOTO $00
 $20  CONTINUE
      ISNA=0
      $IF(HESF<>'NO')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
      $ELSE
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,0,'0\1\2',3)
      $ENDIF
      $IF(MCG=0)
        $SUBST('UF0G$(CON)1')
      $ELSE
        $ADD(SINID)
          CALL UXVSET(NF,ZERO,$GF)
          CALL UXVSET(NF,ONE,$HD)
        $ENDADD
        $SUBST('UF0G$(CON)2')
      $ENDIF
      GOTO ($00,$10) ISB+1
 $30  CONTINUE
      ISNA=ISNS
      $GF=W
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     --------------------------------
*     END OF NUMERICAL DIFFERENTIATION
*     --------------------------------
*
$OPTION(CHDIR=CHPOM)
      $ADD(INIT)
        NFXX='UF1FM1'
      $ENDADD
      $EXIT
